/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2009 C ESCOBAR - christel.escobar@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.controls.pesv2.sig;

import java.util.Hashtable;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

import fr.gouv.finances.cp.xemelios.controls.AbstractUnitControl;
import fr.gouv.finances.cp.xemelios.controls.Anomalie;
import fr.gouv.finances.cp.xemelios.controls.IdGenerator;
import fr.gouv.finances.cp.xemelios.controls.Node;
import fr.gouv.finances.cp.xemelios.controls.pesv2.ConstantsControlsPESv2;

/**
 * Implémente le contrôle N° SIG1
 * Il consiste à vérifier la règle fonctionnelle suivante :
 * 
 * En cas de dématérialisation complète avec présence de signature électronique, le flux doit contenir la présence du caractère dématérialisé de l'information.
 * 		
 * Il est fait ainsi :
 * 
 * - Si la balise InfoDematarialisee est égale à 1 ou true, vérifier que la balise <ds:Signature> (niveau signature globale ou bordereau) est présente
 * - Si la balise InfoDematarialisee est égale à 0 ou false, vérifier que la balise <ds:Signature> (niveau signature globale ou bordereau) est absente
 * 		
 */
public class SIG1 extends AbstractUnitControl implements ConstantsControlsPESv2 {
	private final static Logger logger = Logger.getLogger(SIG1.class);
    public static final transient String CTRL_ID = "SIG1";
	private Hashtable<String,Object> hParams;
	
	/**
	 * La balise du document général
	 */
	private String docId = null;
	private String bord_nodeId = null;

	
	/**
	 * Variables contenant les valeurs nécessaires à ce contrôle
	 */

	private String bord_Exer = "";
	private String bord_IdBord = "";
	private String bord_TypBord = "";
	private String piece_IdPce = "";
	
	private String enTete_infodemat = null;
	private String enTete_infodemat_nodeId = "";
	private boolean signature_isPresent = false;
	
	
	/**
	 * Variables devant être remplacées dans le message
	 */
	private static final String MSG_ERREUR = "#MSG_ERREUR#";

		
	/**
	 * Chemins incomplet vers les divers éléments que l'on veux lire. Ils sont incomplets dans la mesure 
	 * où on n'a pas le début du chemin, vu que ce contrôle est utilisé pour les Dépenses et les Recettes
	 */
	private static final String CHEMIN_BLOCBORDEREAU = "/Bordereau/BlocBordereau/";
	private static final String CHEMIN_BLOCBORDEREAU_EXER = "/Bordereau/BlocBordereau/Exer/";
	private static final String CHEMIN_BLOCBORDEREAU_IDBORD = "/Bordereau/BlocBordereau/IdBord/";
	private static final String CHEMIN_BLOCBORDEREAU_TYPBORD = "/Bordereau/BlocBordereau/TypBord/";
	private static final String CHEMIN_SIGNATURE = "/Signature/";
	private static final String CHEMIN_FIN = "PES_Aller/";
	
	/**
	 * Selon que l'on est en RECETTE ou DEPENSE, le xpath est différent
	 */
	private static final String RECETTE = "PES_RecetteAller";
	private static final String DEPENSE = "PES_DepenseAller";
	private boolean depense = false;

	private static String CHEMIN_BLOCPIECE = "";
	private static String CHEMIN_BLOCPIECE_IDPCE = "";
	private static String CHEMIN_ENTETE = "";
	private static String CHEMIN_ENTETE_INFODEMATERIALISEE = "";
	private static final String R_CHEMIN_BLOCPIECE = "/Bordereau/Piece/BlocPiece/";
	private static final String R_CHEMIN_BLOCPIECE_IDPCE = "/Bordereau/Piece/BlocPiece/IdPce/";
	private static final String R_CHEMIN_ENTETE = "/EnTeteRecette/";
	private static final String R_CHEMIN_ENTETE_INFODEMATERIALISEE = "/EnTeteRecette/InfoDematerialisee/";
	private static final String D_CHEMIN_BLOCPIECE = "/Bordereau/Piece/BlocPiece/";
	private static final String D_CHEMIN_BLOCPIECE_IDPCE = "/Bordereau/Piece/BlocPiece/InfoPce/IdPce/";
	private static final String D_CHEMIN_ENTETE = "/EnTeteDepense/";
	private static final String D_CHEMIN_ENTETE_INFODEMATERIALISEE = "/EnTeteDepense/InfoDematerialisee/";
	
		
	
	public void startDocument() throws SAXException {
		logger.info("In "+CTRL_ID);
	}
	
	public void setDocId(String docID) {
		this.docId = docID;		
	}

	public void startElement(String uri, String localName, String qName,Attributes atts, String xpath) {
		
		// RECETTE ou DEPENSE
		if (xpath.indexOf(DEPENSE)!=-1) {
			depense = true;
			CHEMIN_BLOCPIECE = D_CHEMIN_BLOCPIECE;
			CHEMIN_BLOCPIECE_IDPCE = D_CHEMIN_BLOCPIECE_IDPCE;
			CHEMIN_ENTETE = D_CHEMIN_ENTETE;
			CHEMIN_ENTETE_INFODEMATERIALISEE = D_CHEMIN_ENTETE_INFODEMATERIALISEE;
		}
		if (xpath.indexOf(RECETTE)!=-1) {
			depense = false;
			CHEMIN_BLOCPIECE = R_CHEMIN_BLOCPIECE;
			CHEMIN_BLOCPIECE_IDPCE = R_CHEMIN_BLOCPIECE_IDPCE;
			CHEMIN_ENTETE = R_CHEMIN_ENTETE;
			CHEMIN_ENTETE_INFODEMATERIALISEE = R_CHEMIN_ENTETE_INFODEMATERIALISEE;
		}
		if (xpath.endsWith(CHEMIN_BLOCBORDEREAU)) {
			bord_Exer = bord_IdBord = bord_TypBord = "";
			bord_nodeId = atts.getValue("ano:node-id");
		}
		if (xpath.endsWith(CHEMIN_BLOCBORDEREAU_EXER)) {
			bord_Exer = atts.getValue("V");
		}
		if (xpath.endsWith(CHEMIN_BLOCBORDEREAU_IDBORD)) {
			bord_IdBord = atts.getValue("V");
		}
		if (xpath.endsWith(CHEMIN_BLOCBORDEREAU_TYPBORD)) {
			bord_TypBord = atts.getValue("V");
		}
		if (xpath.endsWith(CHEMIN_BLOCPIECE)) {
			piece_IdPce = "";
		}
		if (xpath.endsWith(CHEMIN_BLOCPIECE_IDPCE)) {
			piece_IdPce = atts.getValue("V");
		}
		if (xpath.endsWith(CHEMIN_ENTETE)) {
			enTete_infodemat = enTete_infodemat_nodeId = null;
		}
		if (xpath.endsWith(CHEMIN_ENTETE_INFODEMATERIALISEE)) {
			enTete_infodemat = atts.getValue("V");
			enTete_infodemat_nodeId = atts.getValue("ano:node-id");
		}
		if (xpath.endsWith(CHEMIN_SIGNATURE)) {
			signature_isPresent = true;
		}
	}
	

	public Vector<Anomalie> endElement(String uri, String localName, String qName, String xpath) throws SAXException {
		boolean err = false;
		String erreur = "";
		if (xpath.endsWith(CHEMIN_FIN)){

			if (("1".equals(enTete_infodemat) || "true".equals(enTete_infodemat) || "yes".equals(enTete_infodemat)) && signature_isPresent == false) {
					err = true;
					erreur = "La balise InfoDematerialisee est valorisée de telle façon que vous attestez la présence d'une signature électronique, hors elle est absente (signature globale ou individuelle)";
			} else if (("0".equals(enTete_infodemat) || "false".equals(enTete_infodemat) || "no".equals(enTete_infodemat)) && signature_isPresent == true) {
					err = true;
					erreur = "Le flux est signé électroniquement mais la balise InfoDematerialisee n'est pas correctement valorisée";
			} else if(signature_isPresent && enTete_infodemat==null) {
                            err = true;
                            erreur = "Le flux est signé électroniquement mais la balise InfoDematerialisee  n?est pas présente";
                        }
			if (err){
				Vector<Anomalie> ano1 = new Vector<Anomalie>();
				
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_ERREUR, erreur);
				
				String path="@added:primary-key='"+bord_Exer+"-"+bord_TypBord+"-"+bord_IdBord+"'";
				String anoId = IdGenerator.nextId();
				String libelleLien = "Bordereau "+bord_IdBord+" Mandat "+piece_IdPce;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "");
				xslParams.put("mandatId", piece_IdPce);
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        xpath.split("/")[0],
                                        (depense?BORDEREAU_DEPENSE:BORDEREAU_RECETTE), // élément importable
                                        bord_IdBord, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
                                if(enTete_infodemat_nodeId!=null)
                                    ano.addNode(new Node(enTete_infodemat_nodeId));
				ano1.add(ano);
				return ano1;
			} else {
				return null;
			}			
		} else {
			return null;
		}
	}

	public void endDocument() throws SAXException {}
	
	public void characters(char[] ch, int start, int length, String xpath) {}
	
	public void ignorableWhitespace(char[] ch, int start, int length,String xpath) {}
	
	public void startPrefixMapping(String prefix, String uri, String xpath) {}
	
	public void endPrefixMapping(String prefix, String xpath) {}
	
	public void processingInstruction(String target, String data, String xpath) {}
	
	public void skippedEntity(String name, String xpath) {}
	
	public void setParameters(Hashtable<String,Object> params) {
		this.hParams=params;
	}
	
	public void setDocumentLocator(Locator locator) {}
}
